package app.revanced.patches.kakaotalk.ads

import app.revanced.patcher.extensions.InstructionExtensions.addInstructions
import app.revanced.patcher.patch.bytecodePatch
import app.revanced.patches.kakaotalk.ads.fingerprints.removeBizBoardFingerprint

@Suppress("unused")
val removeBizBoardPatch = bytecodePatch(
    name = "Remove BizBoard ads",
    description = "Removes the BizBoard ad by forcing its dimensions to 0x0 and visibility to GONE in onMeasure.",
) {
    compatibleWith("com.kakao.talk"("25.4.1"))

    execute {
        val method = removeBizBoardFingerprint.method

        method.addInstructions(
            0,
            """
                const/4 v0, 0x0
                const/4 v1, 0x0
                invoke-virtual {p0, v0, v1}, Landroid/widget/FrameLayout;->setMeasuredDimension(II)V

                invoke-virtual {p0}, Landroid/widget/FrameLayout;->getVisibility()I
                move-result v0

                const/16 v1, 0x8

                if-eq v0, v1, :skip_set_visibility

                invoke-virtual {p0, v1}, Landroid/widget/FrameLayout;->setVisibility(I)V

                :skip_set_visibility

                return-void
            """.trimIndent()
        )
    }
}